using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Net;
using BlogSmart.Blog;
using System.Text.RegularExpressions;

namespace BlogSmart
{
	/// <summary>
	/// Summary description for frmBlog_Manage.
	/// </summary>
	public class frmBlog_Manage : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.TreeView tvBlogEntries;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.MenuItem menuItem1;
	
		public frmBlog_Manage()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.tvBlogEntries = new System.Windows.Forms.TreeView();
			this.lblStatus = new System.Windows.Forms.Label();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.Add(this.menuItem1);
			this.mainMenu1.MenuItems.Add(this.menuItem2);
			// 
			// menuItem1
			// 
			this.menuItem1.Text = "New Post";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.MenuItems.Add(this.menuItem3);
			this.menuItem2.MenuItems.Add(this.menuItem4);
			this.menuItem2.MenuItems.Add(this.menuItem5);
			this.menuItem2.Text = "Blog Smart";
			// 
			// menuItem3
			// 
			this.menuItem3.Text = "Delete Post";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Text = "Edit Post";
			// 
			// menuItem5
			// 
			this.menuItem5.Text = "Exit";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// tvBlogEntries
			// 
			this.tvBlogEntries.ImageIndex = -1;
			this.tvBlogEntries.Location = new System.Drawing.Point(0, 40);
			this.tvBlogEntries.SelectedImageIndex = -1;
			this.tvBlogEntries.Size = new System.Drawing.Size(176, 144);
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Nina", 10F, System.Drawing.FontStyle.Bold);
			this.lblStatus.Location = new System.Drawing.Point(8, 8);
			this.lblStatus.Size = new System.Drawing.Size(160, 22);
			this.lblStatus.Text = "label1";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// frmBlog_Manage
			// 
			this.Controls.Add(this.lblStatus);
			this.Controls.Add(this.tvBlogEntries);
			this.Menu = this.mainMenu1;
			this.Text = "blogSmart!";
			this.Load += new System.EventHandler(this.frmBlog_Manage_Load);

		}
		#endregion

		private void frmBlog_Manage_Load(object sender, System.EventArgs e)
		{	
			// Stuff
			Refresh();

			IPHostEntry ipEntry = Dns.GetHostByName(Dns.GetHostName());
			IPAddress [] addr = ipEntry.AddressList;

			string ipAddress = "";
			for (int i = 0; i < addr.Length; i++)
			{
				ipAddress = ipAddress + addr[i].ToString();
			}
			
			bool a = ipAddress.StartsWith("192.168");
			if (a)
				this.Text = "blogSmart - offline/local";
			else
				this.Text = "blogSmart - online";

			Refresh();

			lblStatus.Text = "Retriving user info...";
			Cursor.Current = Cursors.WaitCursor;
			Refresh();

			BloggerAPI blogger = new BloggerAPI();
			blogger.Url = frmMain.bsConfig.strURL;						
			blogger.UserAgent = "blogSmart! (http://www.0gravity.co.uk/blogsmart)";			
			
			try 
			{
				UserBlog[] userBlogs = blogger.GetUsersBlogs("", "admin", "80e10a");
				foreach (UserBlog blog in userBlogs)
				{
					TreeNode tn = new TreeNode(blog.blogid + " - " + blog.blogName);
					tvBlogEntries.Nodes.Add(tn);				
				}

			}
			catch (CookComputing.XmlRpc.XmlRpcFaultException fex)
			{
				MessageBox.Show("Error occured [FaultCode=" + fex.FaultCode + " FaultString=" + fex.FaultString);
			}

			catch (CookComputing.XmlRpc.XmlRpcIllFormedXmlException)
			{
				MessageBox.Show("While trying to execute GetUserBlogs() the server did not return a valid XML response.", "blogSmart");
				Application.Exit();
			}
			catch (System.UriFormatException)
			{
				MessageBox.Show("It would seem that your URL format is invalid!", "blogSmart");
				Application.Exit();
			}
			catch (System.Net.WebException)
			{
				MessageBox.Show("Unable to connect to " + blogger.Url + " . \nPlease check your connection and try again.", "blogSmart");
				Application.Exit();
			}
						
			lblStatus.Text = "Retriving posts...";
			Refresh();

			// Retrieve the postID and postTitles
			try
			{
				RecentPostTitles[] recentPostTitles = blogger.GetRecentPostTitles("", "admin", "80e10a", 5);
				foreach (RecentPostTitles postTitles in recentPostTitles )								
				{
					tvBlogEntries.Nodes[0].Nodes.Add(postTitles.postid + " : " + postTitles.title);
				}
				tvBlogEntries.ExpandAll();
			}
			catch (CookComputing.XmlRpc.XmlRpcIllFormedXmlException)
			{
				MessageBox.Show("While trying to execute GetRecentPostTitles() the server did not return a valid XML response.", "blogSmart");
				Application.Exit();
			}

			catch (CookComputing.XmlRpc.XmlRpcServerException fex)
			{
				MessageBox.Show("While trying to execute GetRecentPostTitles()...");
				MessageBox.Show(fex.Message);
				MessageBox.Show(fex.InnerException.ToString());
				Application.Exit();
			}

			lblStatus.Text = "Determine connection status...";
			Refresh();

			lblStatus.Text = "";
			Cursor.Current = Cursors.Default;
			Refresh();
						
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			Form a = new frmBlogDetail();					
			a.Show();
		}

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(tvBlogEntries.SelectedNode.Text);
		}
		
	}
}
